#!
# ic.cgi
######################################################################
#
# Image Counter
# Version 1.0
#
# Counter script
#
# Copyright 2000 (c) N.Saito
#
######################################################################
#
# * IMPORTANT NOTE *
#
# (Copyright and Escape Clause)
# 'Image Counter' is FREEWARE, but distribution is not allowed without 
# license.
# not allowed without license.
# The creator of this program is not liable for any damage by using 
# this. 'Image Counter' is protected under the law and the 
# international treaty about copyright. All rights reserved.
#
#   Contact: N.Saito<ghb07031@nifty.ne.jp>
#            http://hpcgi2.nifty.com/sysad/
#
# (Must to do at first)
# At first, you should reconfigure this file. The path to the Perl 
# interpreter at your site may be different from mine. You must rewrite 
# Perl path in the first line of this script file. For example, if your 
# Perl path is '/usr/local/bin/perl', rewrite the first line of this 
# file like this:
#
#   #!/usr/local/bin/perl
#
# Also path to the library file must be modified. The description for 
# tha path to the library is just behind this so long comment section.
# If you put 'gifar.pl', the library file, at the same directory as 
# this script, you should reconfigure the path like this:
#
#   require 'gifar.pl';
#                           # ^ DON'T REMEBER end the line with 
#                           #   semi-colon(';').
#
# And you must setup the path to the configuration file. The 
# configuration file is a plane text file which holds many settings
# for your site.  The path to the configuration file is placed after 
# the path to the library. "$configfile" is it. If you put your 
# configuration file named 'config.cfg' and put it the same directory 
# as this file, you should rewrite the variable as this:
#
#   $configfile = 'config.cfg';
#                           # ^ DON'T REMEBER end the line with 
#                           #   semi-colon(';'), too.
#

# Path to the library
require 'gifar.pl';

# Configuration file
$configfile='count.cfg';




########################################################################
# Main
########################################################################

$accesstime = time();
$scriptname = 'Image Counter Version 1.0';
if ( rindex($ENV{'SCRIPT_NAME'},"/") < 0) {
 $scriptpath = $ENV{'SCRIPT_NAME'};
} else {
 $scriptpath = substr( $ENV{'SCRIPT_NAME'}, 
                       rindex($ENV{'SCRIPT_NAME'},"/")+1 );
}

exit unless ( $ENV{'HTTP_REFERER'} );
%prm = &ParseCGIParams();
%cfg = &LoadConfig( $configfile );

&PushAccessLog( $cfg{'ACCESSLOG'} );
if ( defined($prm{'nc'}) ) {
 $count = $prm{'nc'};
} else {
 $count = &Count($cfg{'COUNTLOG'},$cfg{'HOSTLIST'});
}
if ( $prm{'nv'} ) {         # Non-visible mode
 $img = &gifar'getNullImage();
} else {                    # Visible mode
 $w = $cfg{'DEFAULTWIDTH'};
 $w = $prm{'w'} if ( $prm{'w'} );
 $w = 10 unless ( $w );
 $count = sprintf( '%0'.$w.'d', $count );
 $img = &gifar'generateImage( $cfg{'SRCIMAGE'}, $count );
}
print "Content-type: image/gif\n";
print "Content-length: ".length($img)."\n\n";
binmode( STDOUT );
print $img;
exit;




########################################################################
# Count
########################################################################

# Count
####################################
sub Count {
 my( $clfile, $hlfile ) = @_;
 my( %cnt ) = &LoadCount( $clfile );
 my( @hl ) = &LoadGeneralDefinition( $hlfile );

 # Check visit count by cookie
 if ( $cfg{'COOKIENAME'} ) {
  my( %c ) = &GetCookie();
  &SetCookie( $cfg{'COOKIENAME'}, $accesstime );
  return $cnt{$ENV{'HTTP_REFERER'}} if ( $c{$cfg{'COOKIENAME'}} );
 }

 # Check host
 my( $last );
 my($mm,$ss,$hh,$d,$m,$y,$w,$today,$a) = localtime($accesstime);
 ($mm,$ss,$hh,$d,$m,$y,$w,$last,$a) = localtime($cnt{'LASTACCESS'});
 $cnt{'LASTACCESS'} = $accesstime;
 if ( $hlfile ) {
  if ( $today==$last ) {
   foreach( @hl ) {
    if ( $_ eq $ENV{'HTTP_HOST'} ) {
     &SaveCount($clfile,%cnt);
     return $cnt{$ENV{'HTTP_REFERER'}};
    }
   }
   &PushHost( $hlfile, $ENV{'HTTP_HOST'} );
  } else {
   &ResetHost( $hlfile );
  }
 }

 # Increment
 $cnt{$ENV{'HTTP_REFERER'}} ++;
 &SaveCount( $clfile, %cnt );

 return $cnt{$ENV{'HTTP_REFERER'}};
}




########################################################################
# Gateway
########################################################################

# ParseCGIParams
####################################
sub ParseCGIParams {
 my( %result ) = ();
 my( @q ) = ();
 my( $k, $v );

 # for GET request
 @q = split( /&/, $ENV{'QUERY_STRING'} );
 foreach( @q ) {
  next if ( $_ !~ /([^=]+)=(.*)/ );
  $k=$1; $v = $2;
  $v =~ tr/+/ /;
  $v =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  $result{$k} = $v;
 }

 # for POST request
 if ( $ENV{'REQUEST_METHOD'} =~ /POST/i ) {
  my( $cmdline ) = "";
  sysread( STDIN, $cmdline, $ENV{'CONTENT_LENGTH'} );
  @q = split( /&/, $cmdline );
  foreach( @q ) {
   next if ( $_ !~ /([^=]+)=(.*)/ );
  $k=$1; $v = $2;
  $v =~ tr/+/ /;
  $v =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  $result{$k} = $v;
  }
 }

 # Adjust Carriage Return
 $result{$k} =~ s/\r//g while ( ($k,$v)=each(%result) );

 return %result;
}

# SetCookie
####################################
sub SetCookie {
 local( $k, $v ) = @_;
 my( $str ) = "Set-Cookie: ";
 $v =~ s/(\W)/sprintf("%%%02X",unpack("C",$1))/eg;
 $str .= "$k=$v; ";
 $str .= "expires=". &TimeStamp( $accesstime + 31536000 );      # 1year
 $str .= "; domain=". $ENV{'HTTP_HOST'};
 $str .= "; path=". $ENV{'SCRIPT_NAME'};
 $str .= ";\n";
 return $str;
}

# GetCookie
####################################
sub GetCookie {
 my( %c ) = ();
 return %c if ( !$ENV{'HTTP_COOKIE'} );
 my( $r, $k, $v );
 for $r ( split( /;\s*/, $ENV{'HTTP_COOKIE'} ) ) {
  ( $k, $v ) = split( /=/, $r );
  $v =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C",hex($1))/eg;
  $c{$k} = $v;
 }
 return %c;
}




########################################################################
# File operations
########################################################################

# LoadGeneralDefinition
####################################
sub LoadGeneralDefinition {
 my( $file ) = @_;
 my( @result ) = ();
 open( IN, "<$file" ) || return @result;
 if ( $ENV{'WINDIR'} eq "" ) {          # In UNIX
  flock( IN, 1 );
 }
 while ( <IN> ) {
  chop();
  $_ =~ s/#.*$//g;              # remove comments
  $_ =~ s/^\s*//g;              # remove heading extra spaces
  $_ =~ s/\s*$//g;              # remove tailing extra spaces
  next if ( $_ eq "" );         # next if no descriptions in line.
  $_ =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  push( @result, $_ );
 }
 close( IN );
 return @result;
}

# LoadConfig
####################################
sub LoadConfig {
 my( @f ) = &LoadGeneralDefinition( $_[0] );
 &ErrorDie( "Invalid Configuration File $_[0]" ) unless ( @f );
 my( %r ) = ();
 foreach ( @f ) {
  ( $_ =~ /^(\w+)\s*=\s*/ ) || &ErrorDie( "Misconfiguration found in $configfile: Syntax Error $_" );
  $r{$1} = $';
 }
 return %r;
}

# LoadCount
####################################
sub LoadCount {
 my( @f ) = &LoadGeneralDefinition( $_[0] );
 my( %r ) = ();
 foreach ( @f ) {
  next unless ( $_ =~ /^(\d+)\@/ );
  $r{ $' } = $1;
 }
 return %r;
}

# SaveCount
####################################
sub SaveCount {
 my( $file, %c ) = @_;
 if ( $ENV{'WINDIR'} ne "" ) {          # In Windows
  open( OUT, ">$file" ) || return 0;
 } else {                               # In UNIX
  open( OUT, "+<$file" ) || return 0;
  flock( OUT, 2 );
  truncate( OUT, 0 );
  seek( OUT, 0, 0 );
 }
 print OUT &GenericComments( $file, 'Count Log' );
 my( $k, $v );
 while ( ($k,$v)=each(%c) ) {
  $k =~ s/(\W)/sprintf("%%%02X",unpack("C",$1))/eg;
  print OUT "$v\@$k\n";
 }
 close( OUT );
}

# PushHost
####################################
sub PushHost {
 my( $file, $host ) = @_;
 open( OUT, "+<$file" ) || return;
 if ( !$ENV{'WINDIR'} ) {               # In UNIX
  flock( OUT, 2 );
 }
 print OUT "$host\n";
 close( OUT );
}

# ResetHost
####################################
sub ResetHost {
 my( $file ) = @_;
 if ( $ENV{'WINDIR'} ne "" ) {          # In Windows
  open( OUT, ">$file" ) || return 0;
 } else {                               # In UNIX
  open( OUT, "+<$file" ) || return 0;
  flock( OUT, 2 );
  truncate( OUT, 0 );
  seek( OUT, 0, 0 );
 }
 print OUT &GenericComments( $file, 'Host list' );
 close( OUT );
}

# PushAccessLog
####################################
sub PushAccessLog {
 my( $file ) = @_;
 open( OUT, "+<$file" ) || open( OUT, ">$file" ) || return 0;
 if ( !$ENV{'WINDIR'} ) {               # In UNIX
  flock( OUT, 2 );
 }
 seek( OUT, 0, 2 );
 my($mm,$ss,$hh,$d,$m,$y,$dow,$a,$b) = localtime($accesstime);
 $dow = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" )[$dow];
 $y += 1900 if ( $y < 1900 );
 $m ++;
 $a = "$y/$m/$d ($dow) $hh:$mm:$ss $ENV{'TZ'}";
 print OUT "\n\n<<$accesstime [$a] ";
 print OUT "$ENV{'REQUEST_METHOD'} $ENV{'REQUEST_URI'}\n";
 my( @ec ) = split( /\s*,\s*/, $cfg{'ENVCONCERN'} );
 while ( ($k,$v)=each(%ENV) ) {
  foreach( @ec ) {
   next if ( $k !~ /$_/i );
   $v =~ s/(\W)/sprintf("%%%02X",unpack("C",$1))/eg;
   print OUT "$k=$v\n";
   last;
  }
 }
 close( OUT );
 return 1;
}





########################################################################
# Misc
########################################################################

sub ErrorDie {
 die $_[0];
}

# LineString
####################################
sub LineString {
 my( $p, $c ) = @_;
 my( $i );
 my( $r ) = "";
 for ( $i=0 ; $i<$c ; $i++ ) {
  $r .= $p;
 }
 return $r;
}

# GenericComments
####################################
sub GenericComments {
 my( $f, $t ) = @_;
 return "# $f\n".
 &LineString("#",72)."\n".
 "# \n# $scriptname\n# $t\n# \n".
 &LineString("#",72)."\n".
 "# \n# * WARNING *\n# \n".
 "# DO NOT change the contents of this file if you don't have \n".
 "# enough knowledge.\n# \n";
}
