#!
# report.cgi
######################################################################
#
# Image Counter
# Version 1.0
#
# Report script
#
# Copyright 2000 (c) N.Saito
#
######################################################################

$configfile='count.cfg';



$scriptname = 'Image Counter Version 1.0';
if ( rindex($ENV{'SCRIPT_NAME'},"/") < 0) {
 $scriptpath = $ENV{'SCRIPT_NAME'};
} else {
 $scriptpath = substr( $ENV{'SCRIPT_NAME'}, 
                       rindex($ENV{'SCRIPT_NAME'},"/")+1 );
}

@mode = (
 'Menu',
 'Edit Count',
 'View Access Log'
);
@func = (
 \&MainMenu,
 \&EditCount,
 \&ViewAccessLog
);
%cfg = &LoadConfig( $configfile );
%prm = &ParseCGIParams();
$result = &{$func[$prm{'m'}]}();
print "Content-type: text/html\n\n$result";




########################################################################
# View
########################################################################

# ShowResult
####################################
sub ShowResult {
 my( %h );
 $h{'SCRIPTNAME'} = $scriptname;
 $h{'SCRIPTURL'} = $scriptpath;
 $h{'TITLE'} = $_[0];
 $h{'RESULT'} = $_[1];
 return &InsertString( &tplMain(), %h );
}

# MainMenu
####################################
sub MainMenu {
 my( $r, $i );
 my( @need ) = ( '', 'COUNTLOG', 'ACCESSLOG' );
 $r = "<ul>\n";
 for ( $i=1 ; $i<@mode ; $i++ ) {
  next unless ( defined($cfg{$need[$i]}) );
  $r .= "<li><a href='$scriptpath?m=$i'>$mode[$i]</a></li>";
 }
 $r .= "</ul>\n";
 return &ShowResult( $mode[0], $r );
}

# EditCount
####################################
sub EditCount {
 my( %cnt ) = &LoadCount( $cfg{'COUNTLOG'} );
 my( $r, $k, $v, $i );
 if ( defined($prm{'target'}) && defined($prm{'count'}) ) {
  $cnt{$prm{'target'}} = $prm{'count'};
  &SaveCount( $cfg{'COUNTLOG'}, %cnt );
 }
 $r = 
 "To edit count, check the record to change and enter new count.\n".
 "Then, click [Submit] button.<br>\n".
 "<br>\n<form action='$scriptpath' method='POST'>\n".
 "<input type=hidden name='m' value='1'>\n".
 "<div align=center>\n".
 "<strong>Present Count</strong><br>".
 "<table border=0 cellspacing=1 cellpadding=2>\n".
 " <tr bgcolor=black>\n".
 "  <td nowrap><font color=white>Address</font></td>\n".
 "  <td align=center nowrap><font color=white>Count</font></td>\n".
 " </tr>\n";
 $i = 0;
 while ( ($k,$v)=each(%cnt) ) {
  next if ( $k eq 'LASTACCESS' );
  $r .= ((++$i)%2) ? " <tr>\n" : " <tr bgcolor=silver>\n";
  $r .= " <td nowrap>\n".
        "  <input type=radio name='target' value='$k'>$k</input>\n".
        " </td>\n".
        " <td align=right nowrap>$v</td>\n".
        "</tr>\n";
 }
 $r .= "</table>\n<br>\n<table border=4 cellspacing=0 cellpadding=4>".
 " <tr><td nowrap>New Count</td>\n".
 " <td><input type=text name='count' size=10 maxlength=10></td></tr>\n".
 " <tr><td colspan=2 align=right nowrap>".
 "  <input type=submit>&nbsp;<input type=reset>\n </td></tr>\n".
 "</table>\n</div>\n</form>\n";
 return &ShowResult( $mode[1], $r );
}

# ViewAccessLog
####################################
sub ViewAccessLog {
 my( @l ) = &LoadGeneralDefinition( $cfg{'ACCESSLOG'} );
 my( $r, $i, $s, $d );
 $d = ( $prm{'detail'} ) ? '' : '&detail=1';
 $r = "Click <a href='$scriptpath?m=2$d'>here</a> to switch ".
 "DETAIL/BRIEF view.<br>\n".
 "<br>\n<div align=center><strong>Access Log</strong></div><br>".
 "<table width=100% border=0 cellspacing=1 cellpadding=2>\n".
 " <tr bgcolor=black>\n".
 "  <td align=center nowrap><font color=white>Time</font></td>\n".
 "  <td width=100% nowrap><font color=white>Request</font></td>\n".
 " </tr>\n";
 for ( $i=0, $s=0, $d='' ; $i<@l ; $i++ ) {
  if ( $l[$i] =~ /^<<\d+\s+\[([^\]]+)\]\s+/ ) {
   $r .= "  <td>$d</td>\n" if ( $d );
   $r .= " </tr>\n" if ( $s );
   $r .= ((++$s)%2) ? " <tr>\n" : " <tr bgcolor=silver>\n";
   $r .= "  <td nowrap>$1</td>\n";
   $d = $';
  } elsif ( $prm{'detail'} ) {
   $d .= "<br>\n$l[$i]";
  }
 }
 $r .= "  <td>$d</td>\n" if ( $d );
 $r .= " </tr>\n" if ( @l );
 $r .= "</table>\n";
 return &ShowResult( $mode[2], $r );
}




########################################################################
# Gateway
########################################################################

# ParseCGIParams
####################################
sub ParseCGIParams {
 my( %result ) = ();
 my( @q ) = ();
 my( $k, $v );

 # for GET request
 @q = split( /&/, $ENV{'QUERY_STRING'} );
 foreach( @q ) {
  next if ( $_ !~ /([^=]+)=(.*)/ );
  $k=$1; $v = $2;
  $v =~ tr/+/ /;
  $v =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  $result{$k} = $v;
 }

 # for POST request
 if ( $ENV{'REQUEST_METHOD'} =~ /POST/i ) {
  my( $cmdline ) = "";
  sysread( STDIN, $cmdline, $ENV{'CONTENT_LENGTH'} );
  @q = split( /&/, $cmdline );
  foreach( @q ) {
   next if ( $_ !~ /([^=]+)=(.*)/ );
  $k=$1; $v = $2;
  $v =~ tr/+/ /;
  $v =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  $result{$k} = $v;
  }
 }

 # Adjust Carriage Return
 $result{$k} =~ s/\r//g while ( ($k,$v)=each(%result) );

 return %result;
}




########################################################################
# File operations
########################################################################

# LoadGeneralDefinition
####################################
sub LoadGeneralDefinition {
 my( $file ) = @_;
 my( @result ) = ();
 open( IN, "<$file" ) || return @result;
 if ( $ENV{'WINDIR'} eq "" ) {          # In UNIX
  flock( IN, 1 );
 }
 while ( <IN> ) {
  chop();
  $_ =~ s/#.*$//g;              # remove comments
  $_ =~ s/^\s*//g;              # remove heading extra spaces
  $_ =~ s/\s*$//g;              # remove tailing extra spaces
  next if ( $_ eq "" );         # next if no descriptions in line.
  $_ =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  push( @result, $_ );
 }
 close( IN );
 return @result;
}

# LoadConfig
####################################
sub LoadConfig {
 my( @f ) = &LoadGeneralDefinition( $_[0] );
 &ErrorDie( "Invalid Configuration File $_[0]" ) unless ( @f );
 my( %r ) = ();
 foreach ( @f ) {
  ( $_ =~ /^(\w+)\s*=\s*/ ) || &ErrorDie( "Misconfiguration found in $configfile: Syntax Error $_" );
  $r{$1} = $';
 }
 return %r;
}

# LoadCount
####################################
sub LoadCount {
 my( @f ) = &LoadGeneralDefinition( $_[0] );
 my( %r ) = ();
 foreach ( @f ) {
  next unless ( $_ =~ /^(\d+)\@/ );
  $r{ $' } = $1;
 }
 return %r;
}

# SaveCount
####################################
sub SaveCount {
 my( $file, %c ) = @_;
 if ( $ENV{'WINDIR'} ne "" ) {          # In Windows
  open( OUT, ">$file" ) || return 0;
 } else {                               # In UNIX
  open( OUT, "+<$file" ) || return 0;
  flock( OUT, 2 );
  truncate( OUT, 0 );
  seek( OUT, 0, 0 );
 }
 print OUT &GenericComments( $file, 'Count Log' );
 my( $k, $v );
 while ( ($k,$v)=each(%c) ) {
  $k =~ s/(\W)/sprintf("%%%02X",unpack("C",$1))/eg;
  print OUT "$v\@$k\n";
 }
 close( OUT );
}




########################################################################
# Text operations
########################################################################

# ErrorDie
####################################
sub ErrorDie {
 my( %h ) = ( 'ERROR' => $_[0], 'SCRIPTNAME' => $scriptname );
 print "Content-type: text/html\n\n";
 print &InsertString( &tplError(), %h );
 exit;
}

# InsertString
####################################
sub InsertString {
 my( $src, %h ) = @_;
 my( $k, $v );
 $src =~ s/<!$k>/$v/gi while ( ($k,$v)=each(%h) );
 return $src;
}

# LineString
####################################
sub LineString {
 my( $p, $c ) = @_;
 my( $i );
 my( $r ) = "";
 for ( $i=0 ; $i<$c ; $i++ ) {
  $r .= $p;
 }
 return $r;
}

# GenericComments
####################################
sub GenericComments {
 my( $f, $t ) = @_;
 return "# $f\n".
 &LineString("#",72)."\n".
 "# \n# $scriptname\n# $t\n# \n".
 &LineString("#",72)."\n".
 "# \n# * WARNING *\n# \n".
 "# DO NOT change the contents of this file if you don't have \n".
 "# enough knowledge.\n# \n";
}





########################################################################
# Templates
########################################################################

# tplMain
####################################
sub tplMain {
 return <<TPL_MAIN;
<html>
<head>
<title>Report of [<!SCRIPTNAME>]</title>
</head>
<body bgcolor=white text=black>
<table width=100% cellspacing=0 cellpadding=4 border=4><tr><td>
<big><big><big><strong>
Report from <!SCRIPTNAME><br>
</strong></big></big></big>
</td></tr></table>
<br>
<hr><big><strong><!TITLE></strong></big><hr>
<br>
<!RESULT>
<br>
<hr><div align=right>
Back to 
<a href='<!SCRIPTURL>'>Menu</a></div>
<hr>
<!SCRIPTNAME>
</body>
</html>
TPL_MAIN
}

# tplError
####################################
sub tplError {
 return <<TPL_ERROR;
<html>
<head>
<title>Report of [<!SCRIPTNAME>]</title>
</head>
<body bgcolor=white text=black>
<table width=100% cellspacing=0 cellpadding=4 border=4><tr><td>
<big><big><big><strong>
Report from <!SCRIPTNAME><br>
</strong></big></big></big>
</td></tr></table>
<br>
<hr><big><strong>Error</strong></big><hr>
<br>
<!ERROR>
<br>
<hr><div align=right>
Back to 
<a href='JavaScript:history.back()'>Back</a></div>
<hr>
<!SCRIPTNAME>
</body>
</html>
TPL_ERROR
}
